-- Conectado como CARTERAINVERSION_USER
spool Resultados_Instalacion_Test\03_Creacion_Tablas.log

-- Generado por Oracle SQL Developer Data Modeler 4.0.3.853
--   en:        2015-04-07 16:53:42 CEST
--   sitio:      Oracle Database 11g
--   tipo:      Oracle Database 11g


CREATE TABLE Accion
  (
    ISINId                    CHAR (12) NOT NULL ,
    Ticker                    VARCHAR2 (10) NOT NULL ,
    TickerDescripcion         VARCHAR2 (100) NOT NULL ,
    MercadoId                 CHAR (15) NOT NULL ,
    NumeroAccionesDisponibles INTEGER NOT NULL ,
    NumeroClientesPoseedores  INTEGER NOT NULL ,
    VolumenNegociacion        NUMBER (12,3) NOT NULL 
  ) ;
CREATE  INDEX Accion__IDX ON Accion
  (
    MercadoId ASC
  )
  ;
  ALTER TABLE Accion ADD CONSTRAINT Accion_PK 
	PRIMARY KEY ( ISINId ) ;

CREATE TABLE AccionHistorico
  (
    ISINId      CHAR (12) NOT NULL ,
    FechaCierre DATE NOT NULL ,
    ValorCierre NUMBER (10,3) NOT NULL
  ) ;
ALTER TABLE AccionHistorico ADD CONSTRAINT AccionHistorico_PK 
	PRIMARY KEY ( FechaCierre, ISINId ) ;

CREATE TABLE Cartera
  (
    CarteraId          NUMBER NOT NULL ,
    ClienteId          NUMBER NOT NULL ,
    CarteraDescripcion VARCHAR2 (255) NOT NULL ,
    EstaActivo         CHAR (1) NOT NULL 
  ) ;
CREATE  INDEX Cartera__IDX ON Cartera
  (
    ClienteId ASC
  )
  ;
  ALTER TABLE Cartera ADD CONSTRAINT Cartera_PK 
	PRIMARY KEY ( CarteraId, ClienteId ) ;

CREATE TABLE Cliente
  (
    ClienteId               NUMBER NOT NULL ,
    Nombre                  VARCHAR2 (150) NOT NULL ,
    NIF                     CHAR (9) NOT NULL ,
    Email                   VARCHAR2 (255) ,
    ValorCarteraInversiones NUMBER (19,3) NOT NULL ,
    EstaActivo              CHAR (1) NOT NULL 
  ) ;
ALTER TABLE Cliente ADD CONSTRAINT Cliente_PK PRIMARY KEY ( ClienteId ) ;

CREATE TABLE ClienteHistorico
  (
    ClienteId      NUMBER NOT NULL ,
    ANO            SMALLINT NOT NULL ,
    Mes            SMALLINT NOT NULL ,
    ImporteInicial NUMBER (12,3) NOT NULL ,
    ImporteFinal   NUMBER (12,3) NOT NULL ,
    Beneficio      NUMBER (12,3) NOT NULL ,
    Porcentaje     NUMBER (10,3) NOT NULL 
  ) ;
ALTER TABLE ClienteHistorico ADD CONSTRAINT ClienteHistorico_PK PRIMARY KEY ( ANO, Mes, ClienteId ) ;

CREATE TABLE Est_3_MayorCarteraCliente
  (
    Id                      SMALLINT NOT NULL ,
    ClienteId               NUMBER CONSTRAINT NNC_Clientev1_ClienteId NOT NULL ,
    Nombre                  VARCHAR2 (150) NOT NULL ,
    ValorCarteraInversiones NUMBER (19,3) NOT NULL 
  ) ;
ALTER TABLE Est_3_MayorCarteraCliente ADD CONSTRAINT Est_3_MayorCarteraCliente_PK PRIMARY KEY ( Id ) ;

CREATE TABLE Est_4_MayorVolumenAccion
  (
    Id                 SMALLINT NOT NULL ,
    ISINId             CHAR (12) CONSTRAINT NNC_Est_4__ISINId NOT NULL ,
    Ticker             VARCHAR2 (10) NOT NULL ,
    TickerDescripcion  VARCHAR2 (100) NOT NULL ,
    VolumenNegociacion NUMBER (12,3) NOT NULL 
  ) ;
ALTER TABLE Est_4_MayorVolumenAccion ADD CONSTRAINT Est_4_MayorVolumenAccion_PK PRIMARY KEY ( Id ) ;

CREATE TABLE Log
  (
    ProcesoId           NUMBER NOT NULL ,
    FechaProceso        TIMESTAMP NOT NULL ,
    RSP                 CHAR (2) NOT NULL ,
    NombreProcedimiento VARCHAR2 (50) NOT NULL ,
    ParametrosEntrada   VARCHAR2 (1024) NOT NULL ,
    ParametrosSalida    VARCHAR2 (255) NOT NULL 
  ) ;
ALTER TABLE Log ADD CONSTRAINT Log_PK PRIMARY KEY ( ProcesoId ) ;

CREATE TABLE Mercado
  (
    MercadoId          CHAR (15) NOT NULL ,
    MercadoDescripcion VARCHAR2 (50) NOT NULL 
  ) ;
ALTER TABLE Mercado ADD CONSTRAINT Mercado_PK PRIMARY KEY ( MercadoId ) ;

CREATE TABLE OrdenEstado
  (
    EstadoId               CHAR (1) NOT NULL ,
    EstadoOrdenDescripcion VARCHAR2 (25) NOT NULL 
  ) ;
ALTER TABLE OrdenEstado ADD CONSTRAINT OrdenEstado_PK PRIMARY KEY ( EstadoId ) ;

CREATE TABLE OrdenInversion
  (
    OrdenInversionId  NUMBER NOT NULL ,
    ISINId            CHAR (12) NOT NULL ,
    TipoOrdenId       CHAR (1) NOT NULL ,
    TipoOrigenId      CHAR (1) NOT NULL ,
    FechaIntroduccion DATE NOT NULL ,
    EstadoId          CHAR (1) NOT NULL ,
    FechaEjecucion    DATE NOT NULL ,
    Cantidad          INTEGER NOT NULL ,
    PrecioMinimo      NUMBER (10,3) ,
    EjecucionPrecio   NUMBER (10,3) ,
    SignoTipoOrden    SMALLINT NOT NULL ,
    CarteraId         NUMBER NOT NULL ,
    ClienteId         NUMBER NOT NULL
  ) ;
ALTER TABLE OrdenInversion ADD CONSTRAINT res_cantidad_Orden 
			CHECK ( Cantidad BETWEEN 0 AND 999999999) ;
CREATE   INDEX OrdenInversion__IDX ON OrdenInversion ( TipoOrdenId ASC ) ;
CREATE   INDEX OrdenInversion__IDXv1 ON OrdenInversion ( EstadoId ASC ) ;
CREATE   INDEX OrdenInversion__IDXv2 ON OrdenInversion ( TipoOrigenId ASC ) ;
CREATE   INDEX OrdenInversion__IDXv3 ON OrdenInversion ( ISINId ASC ) ;
ALTER TABLE OrdenInversion ADD CONSTRAINT 
  OrdenInversion_PK PRIMARY KEY ( OrdenInversionId, CarteraId, ClienteId ) ;

CREATE TABLE OrdenTrading
  (
    OrdenTradingId NUMBER NOT NULL ,
    CarteraId      NUMBER NOT NULL ,
    ClienteId      NUMBER NOT NULL ,
    ISINId         CHAR (12) NOT NULL ,
    TipoOrdenId    CHAR (1) NOT NULL ,
    Cantidad       INTEGER NOT NULL ,
    PrecioMinimo   NUMBER (10,3) ,
    TradingId      CHAR (10) NOT NULL
  ) ;
CREATE   INDEX OrdenTrading__IDX ON OrdenTrading
  (
    TipoOrdenId ASC
  )
  ;
CREATE   INDEX OrdenTrading__IDXv1 ON OrdenTrading
  (
    TradingId ASC
  )
  ;
  ALTER TABLE OrdenTrading ADD CONSTRAINT OrdenTrading_PK PRIMARY KEY ( OrdenTradingId ) ;

CREATE TABLE Rel_SitCarter_OrdenInv
  (
    SituacionCartera_ClienteId NUMBER NOT NULL ,
    SituacionCartera_ISINId    CHAR (12) NOT NULL ,
    OrdenInversion_OrdenInvId  NUMBER NOT NULL ,
    OrdenInversion_CarteraId   NUMBER NOT NULL ,
    OrdenInversion_ClienteId   NUMBER NOT NULL
  ) ;
ALTER TABLE Rel_SitCarter_OrdenInv ADD CONSTRAINT Relation_17_PK 
PRIMARY KEY ( SituacionCartera_ClienteId, SituacionCartera_ISINId, 
			OrdenInversion_OrdenInvId, OrdenInversion_CarteraId, 
			OrdenInversion_ClienteId ) ;

CREATE TABLE SituacionCartera
  (
    ClienteId              NUMBER NOT NULL ,
    ISINId                 CHAR (12) NOT NULL ,
    ValorCotizacionUlt     NUMBER NOT NULL ,
    FechaCotizacionUlt     DATE NOT NULL ,
    Importe                NUMBER NOT NULL ,
    Cantidad               NUMBER NOT NULL ,
    CantidadPendienteVenta NUMBER NOT NULL 
  ) ;
ALTER TABLE SituacionCartera ADD CONSTRAINT SituacionCartera_PK 
		PRIMARY KEY ( ClienteId, ISINId ) ;

CREATE TABLE TipoOrden
  (
    TipoOrdenId          CHAR (1) NOT NULL ,
    TipoOrdenDescripcion VARCHAR2 (15) NOT NULL ,
    SignoTipoOrden       SMALLINT NOT NULL
  ) ;
ALTER TABLE TipoOrden ADD CONSTRAINT TipoOrden_PK PRIMARY KEY ( TipoOrdenId ) ;

CREATE TABLE TipoOrigen
  (
    TipoOrigenId          CHAR (1) NOT NULL ,
    TipoOrigenDescripcion VARCHAR2 (15) NOT NULL 
  ) ;
ALTER TABLE TipoOrigen ADD CONSTRAINT TipoOrigen_PK PRIMARY KEY ( TipoOrigenId ) ;

CREATE TABLE Trading
  (
    TradingId          CHAR (10) NOT NULL ,
    TradingDescripcion VARCHAR2 (100) NOT NULL 
  ) ;
ALTER TABLE Trading ADD CONSTRAINT Trading_PK PRIMARY KEY ( TradingId ) ;

ALTER TABLE AccionHistorico ADD CONSTRAINT AccionHistorico_Accion_FK 
	FOREIGN KEY ( ISINId ) REFERENCES Accion ( ISINId ) ;

ALTER TABLE Accion ADD CONSTRAINT Accion_Mercado_FK 
	FOREIGN KEY ( MercadoId ) REFERENCES Mercado ( MercadoId ) ;

ALTER TABLE Cartera ADD CONSTRAINT Cartera_Cliente_FK 
	FOREIGN KEY ( ClienteId ) REFERENCES Cliente ( ClienteId ) ;

ALTER TABLE ClienteHistorico ADD CONSTRAINT ClienteHistorico_Cliente_FK 
	FOREIGN KEY ( ClienteId ) REFERENCES Cliente ( ClienteId ) ;

ALTER TABLE Rel_SitCarter_OrdenInv ADD CONSTRAINT FK_ASS_2 
	FOREIGN KEY ( SituacionCartera_ClienteId, SituacionCartera_ISINId ) 
	REFERENCES SituacionCartera ( ClienteId, ISINId ) ;

ALTER TABLE Rel_SitCarter_OrdenInv ADD CONSTRAINT FK_ASS_3 
	FOREIGN KEY ( OrdenInversion_OrdenInvId, OrdenInversion_CarteraId, 
				OrdenInversion_ClienteId ) 
	REFERENCES OrdenInversion ( OrdenInversionId, CarteraId, ClienteId ) ;

ALTER TABLE OrdenInversion ADD CONSTRAINT OrdenInversion_Accion_FK 
	FOREIGN KEY ( ISINId ) REFERENCES Accion ( ISINId ) ;

ALTER TABLE OrdenInversion ADD CONSTRAINT OrdenInversion_Cartera_FK 
	FOREIGN KEY ( CarteraId, ClienteId ) 
	REFERENCES Cartera ( CarteraId, ClienteId ) ;

ALTER TABLE OrdenInversion ADD CONSTRAINT OrdenInversion_OrdenEstado_FK 
	FOREIGN KEY ( EstadoId ) 
	REFERENCES OrdenEstado ( EstadoId ) ;

ALTER TABLE OrdenInversion ADD CONSTRAINT OrdenInversion_TipoOrden_FK 
	FOREIGN KEY ( TipoOrdenId ) 
	REFERENCES TipoOrden ( TipoOrdenId ) ;

ALTER TABLE OrdenInversion ADD CONSTRAINT OrdenInversion_TipoOrigen_FK 
	FOREIGN KEY ( TipoOrigenId ) 
	REFERENCES TipoOrigen ( TipoOrigenId ) ;

ALTER TABLE OrdenTrading ADD CONSTRAINT OrdenTrading_Cliente_FK 
	FOREIGN KEY ( ClienteId ) 
	REFERENCES Cliente ( ClienteId ) ;

ALTER TABLE OrdenTrading ADD CONSTRAINT OrdenTrading_TipoOrden_FK 
	FOREIGN KEY ( TipoOrdenId ) 
	REFERENCES TipoOrden ( TipoOrdenId ) ;

ALTER TABLE OrdenTrading ADD CONSTRAINT OrdenTrading_Trading_FK 
	FOREIGN KEY ( TradingId ) 
	REFERENCES Trading ( TradingId ) ;

spool off;