--------------------------------------------------------
-- Archivo creado  - domingo-abril-19-2015   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Package GestionTest
--------------------------------------------------------

CREATE OR REPLACE PACKAGE "CARTERAINVERSION_USER"."GESTIONTEST" AS

PROCEDURE ins_AccionHistorico
(
  paramISINId 				IN AccionHistorico.ISINId%TYPE, 
  paramFechaCierre 			IN AccionHistorico.FechaCierre%TYPE, 
  paramValorCierre			IN AccionHistorico.ValorCierre%TYPE, 
  RSP						OUT NOCOPY VARCHAR2
);

PROCEDURE ins_OrdenInversion
(
  paramISINId				IN OrdenInversion.ISINId%TYPE,
  paramTipoOrdenId			IN OrdenInversion.TipoOrdenId%TYPE,
  paramTipoOrigenId			IN OrdenInversion.TipoOrigenId%TYPE,
  paramCantidad				IN OrdenInversion.Cantidad%TYPE,
  paramPrecioMinimo			IN OrdenInversion.PrecioMinimo%TYPE,
  paramCarteraId			IN OrdenInversion.CarteraId%TYPE,
  paramClienteId			IN OrdenInversion.ClienteId%TYPE,
  RSP						OUT NOCOPY VARCHAR2,
 paramFechaIntroduccion     IN OrdenInversion.FechaIntroduccion%type := to_date('01/01/00','DD/MM/YY') /* parametros opcionales, van siempre al final */
);

PROCEDURE upd_OrdenInversion
(
  paramOrdenInversionId			IN OrdenInversion.OrdenInversionId%TYPE,
  paramCarteraId				IN OrdenInversion.CarteraId%TYPE,
  paramClienteId				IN OrdenInversion.ClienteId%TYPE,
  paramCantidad					IN OrdenInversion.Cantidad%TYPE,
  paramEjecucionPrecio			IN OrdenInversion.EjecucionPrecio%TYPE,
  paramEstadoId					IN OrdenInversion.EstadoId%TYPE,
  RSP							OUT NOCOPY VARCHAR2,
  paramFechaEjecucion           IN OrdenInversion.FechaEjecucion%type := to_date('01/01/00','DD/MM/YY') /* parametros opcionales, van siempre al final */
);

PROCEDURE ins_OrdenTrading
(
  paramCarteraId		IN OrdenTrading.CarteraId%TYPE, 
  paramClienteId		IN OrdenTrading.ClienteId%TYPE, 
  paramISINId			IN OrdenTrading.ISINId%TYPE, 
  paramTipoOrdenId		IN OrdenTrading.TipoOrdenId%TYPE, 
  paramCantidad			IN OrdenTrading.Cantidad%TYPE, 
  paramPrecioMinimo		IN OrdenTrading.PrecioMinimo%TYPE,
  paramTradingId		IN OrdenTrading.TradingId%TYPE, 
  RSP					OUT NOCOPY VARCHAR2
);

PROCEDURE upd_OrdenTrading 
(
  paramOrdenTradingiD	IN OrdenTrading.OrdenTradingId%TYPE, 
  paramCarteraId		IN OrdenTrading.CarteraId%TYPE, 
  paramClienteId		IN OrdenTrading.ClienteId%TYPE, 
  paramISINId			IN OrdenTrading.ISINId%TYPE, 
  paramTipoOrdenId		IN OrdenTrading.TipoOrdenId%TYPE, 
  paramCantidad			IN OrdenTrading.Cantidad%TYPE, 
  paramPrecioMinimo		IN OrdenTrading.PrecioMinimo%TYPE, 
  paramTradingId		IN OrdenTrading.TradingId%TYPE, 
  RSP					OUT NOCOPY VARCHAR2
);

PROCEDURE del_OrdenTrading
( 
	paramOrdenTradingiD		    IN OrdenTrading.OrdenTradingId%TYPE, 
	RSP							OUT NOCOPY VARCHAR2
);

PROCEDURE exe_OrdenTrading
(
	paramOrdenTradingiD		    IN OrdenTrading.OrdenTradingId%TYPE,
	RSP							OUT NOCOPY VARCHAR2
);

PROCEDURE ins_ClienteHistorico
(
  paramClienteiD		    IN ClienteHistorico.ClienteId%TYPE, 
  paramMes					IN ClienteHistorico.Mes%TYPE, 
  paramANO					IN ClienteHistorico.ANO%TYPE,
  paramImporteInicial		IN ClienteHistorico.ImporteInicial%TYPE,
  paramImporteFinal			IN ClienteHistorico.ImporteFinal%TYPE,  
  RSP						OUT NOCOPY VARCHAR2
);

PROCEDURE upd_ClienteHistorico 
(
  paramClienteiD	    IN ClienteHistorico.ClienteId%TYPE, 
  paramMes				IN ClienteHistorico.Mes%TYPE, 
  paramANO				IN ClienteHistorico.ANO%TYPE, 
  paramImporteInicial	IN ClienteHistorico.ImporteInicial%TYPE,
  paramImporteFinal		IN ClienteHistorico.ImporteFinal%TYPE,  
  RSP					OUT NOCOPY VARCHAR2
);

END GESTIONTEST;

/


